#include "Komplex.h"
#include <iostream>

//Komplex Komplex::operator+(const Komplex& rhs) const{
//    Komplex temp;
//    temp.re = re + rhs.re;
//    temp.im = im + rhs.im;
//    return temp;
//}
//Komplex Komplex::operator*(const Komplex &rhs) const {
//	return Komplex(re*rhs.re - im*rhs.im, im*rhs.re + re*rhs.im);
//}

const Komplex Komplex::i = Komplex(0,1);

Komplex operator+(const Komplex& l, const Komplex& r){
	Komplex temp;
	temp.re = l.re + r.re;
	temp.im = l.im + r.im;
	return temp;
} // Att denna r friend syns bara i deklarationen

Komplex operator*(const Komplex& l, const Komplex& r){
	return Komplex(l.re*r.re - l.im*r.im, l.im*r.re + l.re*r.im);
} // Att denna r friend syns bara i deklarationen


std::ostream& operator<<(std::ostream& o, const Komplex& a) {
	o << a.re << "+";
	if (a.im != 0.0) o <<a.im;
	o << "i";
	return o;
}
