#pragma once
#include <ostream>

class Komplex {
public:
	Komplex() : re(1), im(0) {}
	Komplex(double r) : re(r), im(0) {}
	Komplex(double r, double i) : re(r), im(i) {}
	//Komplex operator+(const Komplex &rhs) const;
	//Komplex operator*(const Komplex &rhs) const;
	// De andra medlemsfunktionerna som t.ex.
	// operator-, operator/, get_re, set_re ...

	static const Komplex i;

	friend Komplex operator+(const Komplex& l, const Komplex& r);
	friend Komplex operator*(const Komplex& l, const Komplex& r);
	friend std::ostream& operator<<(std::ostream& o, const Komplex&  v);
private:
	double re, im;
};
