#pragma once

//template<class D>
//class Trad {
//public:
//	Trad() : rot(nullptr) {}
//	Trad(D d) { rot = new Nod<D>(d); }
//	~Trad() { delete rot; }
//	bool tomt() const { return rot == nullptr; }
//	D& varde() const { koll(); return rot->data; }
//	Trad& v_barn() const { koll(); return *rot->vanster; }
//	Trad& h_barn() const { koll(); return *rot->hoger; }
//	void satt_in(D d);
//	D* sok(D d);
//private:
//	class Nod {
//		friend class Trad<D>;
//		D data;
//		Trad<D> *vanster, *hoger;
//		Nod(D d) : data(d), vanster(new Trad), hoger(new Trad) {}
//		~Nod() { delete vanster; delete hoger; }
//	};
//	Nod *rot;
//	void koll() const { if (tomt()) throw range_error("Trad"); }
//};

template<class D>
class Trad {
public:
	Trad() : rot(nullptr) {}
	Trad(D d) { rot = new Nod<D>(d); }
	~Trad() { delete rot; }
	bool tomt() const { return rot == nullptr; }
	D& varde() const { koll(); return rot->data; }
	Trad& v_barn() const { koll(); return rot->vanster; }
	Trad& h_barn() const { koll(); return rot->hoger; }
	void satt_in(D d);
	D* sok(D d);
private:
	class Nod {
		friend class Trad<D>;
		D data;
		Trad<D> vanster, hoger;
		Nod(D d) : data(d) {}
		~Nod() {}
	};
	Nod *rot;
	void koll() const { if (tomt()) throw range_error("Trad"); }
};

// Insttning i binrt sktrd
template<class D>
void Trad<D>::satt_in(D d) {
	if (tomt())
		rot = new Nod(d);
	else if (d < varde())
		v_barn().satt_in(d);
	else
		h_barn().satt_in(d);
}

// Skning i binrt sktrd
template<class D>
D* Trad<D>::sok(D d) {
	if (tomt())
		return nullptr;
	else if (d == varde())
		return &varde();
	else if (d < varde())
		return v_barn().sok(d);
	else
		return h_barn().sok(d);
}
